#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <strings.h>

typedef struct { char codice[7];
                 char descrizione[40];
                 int giacenza; } Art;

typedef struct { char codice[7];
                 int quantita; } Movim;
                 
void inizMov();
void caricaElementi();
void leggiArt(char nome[]);
void leggiMov(char nome[]);
int cercaArt(char nome[],char codice[]);
void modificaGiac(int cerca, int quantita);
void aggMov(Movim m);

int main() {
    FILE *fp;
    char codice[7];
    Art a;
    Movim m;
    int c,giac,cerca;
  //  caricaElementi();
    inizMov();
    leggiArt("magazzino.dat");
    do {
       printf("Introduci 'v' per vendere o 'a' per acquistare, ESC per uscire\n");
       do {
        c=getch();
        } while((c!='v')&&(c!='a')&&(c!=27)); 
        putch(c);    
        if(c=='a') {
               printf("\nIntroduci il codice dell'articolo\n");
               fflush(stdin);
               scanf("%s",m.codice);
               printf("Introduci la quantita\n");
               fflush(stdin);
               scanf("%d",&m.quantita);
               cerca=cercaArt("magazzino.dat",m.codice);
               if(cerca==-1) 
                          printf("L'articolo corrispondente non esiste\n");
               else {
                    modificaGiac(cerca,m.quantita);
                    aggMov(m);
               }
        }
        else
        if(c=='v') {
               printf("\nIntroduci il codice dell'articolo\n");
               fflush(stdin);
               scanf("%s",m.codice);
               printf("Introduci la quantita\n");
               fflush(stdin);
               scanf("%d",&m.quantita);
               cerca=cercaArt("magazzino.dat",m.codice);
               printf("\n%d\n",cerca);
               if(cerca==-1) 
                          printf("L'articolo corrispondente non esiste\n");
               else {
                    fp=fopen("magazzino.dat","rb");
                    fseek(fp,cerca*sizeof(Art),SEEK_SET);
                    fread(&a,sizeof(Art),1,fp);
                    if(m.quantita>a.giacenza) {
                                             printf("Non  possibile compiere l'azione\n");
                                             fclose(fp); }
                    else {
                         m.quantita=-(m.quantita);
                         modificaGiac(cerca,m.quantita);
                         aggMov(m);
                    }
               }
        }
    } while(c!=27);
    leggiArt("magazzino.dat");
    getch();
    return 0;
}

void caricaElementi() {
     int i,n;
     Art a;
     FILE *fp;
     fp=fopen("magazzino.dat","wb");
     printf("Introduci il numero di articoli da inserire\n");
     scanf("%d",&n);
     for(i=0;i<n;i++) {
                      printf("Introduci il codice dell'articolo (6car)\n");
                      fflush(stdin);
                      scanf("%s",a.codice);
                      printf("Introduci la descrizione dell'articolo (max 40 car)\n");
                      fflush(stdin);
                      gets(a.descrizione);
                      printf("Introduci la giacenza dell'articolo\n");
                      fflush(stdin);
                      scanf("%d",&a.giacenza); 
                      fwrite(&a,sizeof(Art),1,fp);
     }                 
     fclose(fp);    
}

void inizMov() {
     FILE *fp;
     fp=fopen("movimenti.dat","wb");
     fclose(fp);
}

void leggiMov(char nome[]) {
     FILE *fp;
     Movim m;
     fp=fopen(nome,"rb");
     fread(&m,sizeof(Movim),1,fp);
     printf("codice: %s\n",m.codice);
     printf("quantit: %d\n",m.quantita);
     while(!(feof(fp))) {
                        fread(&m,sizeof(Art),1,fp);
                        printf("codice: %s\n",m.codice);
                        printf("quantit: %d\n",m.quantita);
     }
}

void leggiArt(char nome[]) {
     FILE *fp;
     Art a;
     fp=fopen(nome,"rb");
     fread(&a,sizeof(Art),1,fp);
     while(!(feof(fp))) {
                        printf("codice: %s\n",a.codice);
                        printf("descrizione: %s\n",a.descrizione);
                        printf("giacenza: %d\n",a.giacenza);
                        fread(&a,sizeof(Art),1,fp);
     }
}

int cercaArt(char nome[],char codice[]) {
    FILE *fp;
    Art a;
    int trovato=0,pos=-1;
    fp=fopen(nome,"rb");
    fread(&a,sizeof(Art),1,fp);
    while(!(feof(fp))&&(!trovato)) {
                       if(strcmp(codice,a.codice)==0)
                                                     trovato=1;
                       pos++;
                       fread(&a,sizeof(Art),1,fp);
    }
    fclose(fp);
    if(trovato)
               return pos;
    else
        return -1;    
}

void modificaGiac(int cerca,int quantita) {
     FILE *fp;
     Art a;
     fp=fopen("magazzino.dat","r+b");
     fseek(fp,cerca*sizeof(Art),SEEK_SET);
     fread(&a,sizeof(Art),1,fp);
     a.giacenza+=quantita;
     fseek(fp,cerca*sizeof(Art),SEEK_SET);
     fwrite(&a,sizeof(Art),1,fp);
     fclose(fp);
}

void aggMov(Movim m) {
     FILE *fp;
     fp=fopen("movimenti.dat","ab");
     fwrite(&m,sizeof(Movim),1,fp);
     fclose(fp);     
}
     
